/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */

var app = {
    PASSWORD_LENGTH: 4, // Longitud minima para el password
    //appVerion: '0.0',
    appVersion: '1.0',
    salt: 'Z8IVe3v7+$H6X,=,)-3o',
    //restServer:'http://192.168.0.100/projects/feasan-webapp/index.php',
    restServer: 'http://despacho.artresnet.com:8080/feasan-webapp/index.php',
    lastSync: null,
    mesCalendario: null,
    isScroll:0,
    actualScreen: '',
    // Almacena objeto PageSlider para la app
    slider: null,
    // Base de datos
    db: null,
    // Application Constructor
    initialize: function() {
        this.bindEvents();
    },
    // Bind Event Listeners
    //
    // Bind any events that are required on startup. Common events are:
    // 'load', 'deviceready', 'offline', and 'online'.
    altura: 0,
    bindEvents: function() {
        document.addEventListener('backbutton', this.onBackButtonClick, false);
        document.addEventListener('deviceready', this.onDeviceReady, false);
        /*document.addEventListener("showkeyboard", function() {
            if(app.actualScreen=='#inicio' || app.actualScreen=='#inicio2'){
                $('.app').addClass('tecladoFuera');
                $('.app').height(app.altura);
                $('#backregistro1').hide();
            }
        }, false);
        document.addEventListener("hidekeyboard", function() {
            //if(app.actualScreen=='#inicio' || app.actualScreen=='#inicio2'){
                $('.app').removeClass('tecladoFuera');
                $('.app').height(app.altura);
                $('#backregistro1').show();
            //}
        }, false);*/
    },
    //$('.app').addClass('tecladoFuera');
    //$('.app').removeClass('tecladoFuera');
    //Evento para cuando se muestra el teclado
    // Evento del botón de volver atras del dispositivo
    onBackButtonClick: function() {
        if (global.debug)
            console.log("onBackButtonClick. actualScreen: " + app.actualScreen);

        if (app.actualScreen == '#modificainr') {
            app.clickEvent('#tuinr');
            app.actualScreen = '#tuinr';

        } else if (app.actualScreen == '#introfecha') {
            app.clickEvent('#modificainr');
            app.actualScreen = '#modificainr';

        } else if (app.actualScreen == '#listadosis') {
            app.clickEvent('#tudosis');
            app.actualScreen = '#tudosis';

        } else if (app.actualScreen == '#introdosis') {
            app.clickEvent('#listadosis');
            app.actualScreen = '#listadosis';

        } else if (app.actualScreen == '#introfecharev') {
            app.clickEvent('#turevision');
            app.actualScreen = '#turevision';

        } else if (app.actualScreen == '#inicio2') {
            app.clickEvent('#inicio');
            app.actualScreen = '#inicio';

        } else if (app.actualScreen.match("^#pregunta")) {
            app.clickEvent('#guia');
            app.actualScreen = '#guia';

        //} else if (app.actualScreen == '#inicio' || app.actualScreen == '#valorinr') {
            // No hacemos nada en este caso
            //return;

        } else {
            app.clickEvent('#valorinr');
            app.actualScreen = '#valorinr';
        }
        app.clickEvent(app.actualScreen);
    },
    // deviceready Event Handler
    //
    // The scope of 'this' is the event. In order to call the 'receivedEvent'
    // function, we must explicity call 'app.receivedEvent(...);'
    onDeviceReady: function() {
        app.altura=$(window).height();
        if (global.debug)
            console.log("onDeviceReady");
        app.init();
        // Si email y password estan definidos, pasamos directamente a la pagina "valorinr"
        if (dao.getEmail() != null && dao.getPassword() != null) {
            if (!global.disableServer)
                restful.init(dao.getEmail());

            app.clickEvent("#valorinr");
            //app.clickEvent("#tudosis");

            if (!global.disableServer && !dao.isUpToDate()) {
                app.db.transaction(dao.checkServer, dao.errorCB);
            }
        }

        else {
            if (global.debug)
                console.log("User or password not defined.");

            if (!global.disableServer)
                dao.setUpToDate('1');

            app.clickEvent('#inicio');
        }
        dao.rellenarPerfil();

        app.db.transaction(dao.pagprincipal, dao.errorCB);
        app.db.transaction(dao.dosis, dao.errorCB);
        app.db.transaction(dao.revision, dao.errorCB);

        //Hide all pages on right
        $(".right").hide();

        //Para todos los enlaces iran a la pantalla definida en el href
        $("a").on('click', function() {
            if (global.debug)
                console.log("generic click event");
            //Comprobamos que se ha verificado los requisitos para continuar los eventos
            if ($(this).attr("data-check") != '' && val.verifyRequirements($(this).attr("data-check"))) {
                if (global.debug)
                    console.log("generic click event, requeriments verified.");
                // Si el elemento es diferente al teclado u otros elementos como checks... 
                if (($(this).attr("data-type") != "keyboard") && ($(this).attr("data-type") != "check")) {
                    if (app.actualScreen != $(this).attr('href')) {
                        app.clickEvent($(this).attr('href'));
                    }
                }
                // Los checks alternan de valor (toggle) con la clase active
                else if ($(this).attr("data-type") == "check") {
                    if ($(this).hasClass('active')) {
                        $(this).removeClass('active');
                        $(this).val(0);
                    } else {
                        $(this).addClass('active');
                        $(this).val(1);
                    }
                }
            }
            return false;
        });

        //Registrando eventos
        $('#registro1').click(function() {
            if (global.debug)
                console.log("#registro1 click");
            dao.saveEmail($('#email').val());
        });

        $('#registro2').click(function() {
            if (global.debug)
                console.log("#registro2 click");
            dao.savePassword(hex_md5($('#contrasenya').val() + global.SALT));

            if (global.disableServer) {
                app.clickEvent('#miperfil');
            } else {
                restful.user('POST', dao.getEmail(), dao.getPassword());
                $.blockUI({message: '<div id="throbber"><img src="img/throbber.gif"/><br/>Conectando con el servidor...</div>'});
            }
        });

        $('#ok_inr').click(function() {
            if (global.debug)
                console.log("#ok_inr click");
            if (global.debug)
                console.log("$('#resultado').val(): " + $('#resultado').val());
            if ($('#resultado').val() == '') {
                if ($('#resultado').attr('placeholder') != '') {
                    $('#resultado').val($('#resultado').attr('placeholder'));
                    if (global.debug)
                        console.log("$('#resultado').val(): " + $('#resultado').val());
                    app.db.transaction(dao.checkInr, dao.errorCB);
                } else {
                    navigator.notification.alert(
                            'Debe introducir un valor en el campo INR para poder guardar.',
                            null, // callback
                            'Aviso', // title
                            'Aceptar'									// buttonName
                            );
                    return false;
                }
            } else {
                if ($('#resultado').val() <= 8) {
                    app.db.transaction(dao.checkInr, dao.errorCB);
                } else {
                    navigator.notification.alert(
                            'El valor del inr no puede ser superior a 8.0.',
                            null, // callback
                            'Aviso', // title
                            'Aceptar'									// buttonName
                            );
                }
            }
        });

        $('#edit_fecha').click(function() {
            if (global.debug)
                console.log("#edit_fecha click");
            if (global.debug)
                console.log("#fechainr: " + $("#fechainr").html());
            if ($("#fechainr").html() != '')
                $('#dateInr').val(dao.dateToStr(dao.strToDate($("#fechainr").html()), false, true));
            else
                $('#dateInr').val(dao.dateToStr(new Date(), false, true));
        });

        $('#estadisticas-mas').click(function(){
            if (global.debug) console.log("#Historico INR click");
            app.db.transaction(dao.historicoInr, dao.errorCB);
        });

        $('#ok_fechaInr').click(function() {
            if (global.debug)
                console.log("#ok_fechaInr click");
            var fecha = $('#dateInr').val();
            fecha = fecha.split('/');
            //corrección
            fecha[1] = fecha[1] - 1;
            $("#fechaActual").html(dao.dateToStr(new Date(fecha[2], fecha[1], fecha[0], 0, 0, 0, 0)));
        });

        $('#calendario-dosis-enlace').click(function() {
            if (global.debug)
                console.log("#calendario-dosis click");
            //global.mesCalendario = new Date(dao.nuevaFecha());
            global.mesCalendario = new Date(dao.nuevaFecha());
            app.db.transaction(dao.dosisMes, dao.errorCB);
        });

        $('#calendario-dosis-mesanterior').click(function() {
            if (global.debug)
                console.log("#calendario-dosis-mesanterior click");
            global.mesCalendario = new Date(global.mesCalendario).setMonth(new Date(global.mesCalendario).getMonth() - 1);
            app.db.transaction(dao.dosisMes, dao.errorCB);
        });

        $('#calendario-dosis-messiguiente').click(function() {
            if (global.debug)
                console.log("#calendario-dosis-messiguiente click");
            global.mesCalendario = new Date(global.mesCalendario).setMonth(new Date(global.mesCalendario).getMonth() + 1);
            app.db.transaction(dao.dosisMes, dao.errorCB);
        });

        $('#ok_dosis').click(function() {
            if (global.debug)
                console.log("#ok_dosis click");
            if (global.debug)
                console.log("nueva dosis: " + global.nuevaDosis);
            if ($('#resultado2').val() == '') {
                navigator.notification.alert(
                        'Debe introducir un valor en el campo Dosis para poder guardar.',
                        null, // callback
                        'Aviso', // title
                        'Aceptar'									// buttonName
                        );
                return false;
            }else{
                if ($('#resultado2').val() <= 10) {
                    var dosisFront=$('#resultado2').val();
                    if (dosisFront % 1 == 0) {
                        dosisFront = dosisFront + '.0';
                    }
					window.localStorage.setItem("dosisGeneral", dosisFront);
                    $('#dosisactual').val(dosisFront);
                    if (global.nuevaDosis) {
                        app.db.transaction(dao.newDosis, dao.errorCB);
                    } else {
                        app.db.transaction(dao.updateDosis, dao.errorCB);
                    }
                } else {
                    navigator.notification.alert(
                        'La dosis no puede ser superior a 10mg.',
                        null, // callback
                        'Aviso', // title
                        'Aceptar'                                   // buttonName
                    );
                }
            }
            app.db.transaction(dao.dosisMes, dao.errorCB);
        });

        $('#ok_dateRevision').click(function() {
            if (global.debug)
                console.log("#ok_dateRevision click");
            app.db.transaction(dao.newRevision, dao.errorCB);
        });

        $('#ok_perfil').click(function() {
            if (global.debug)
                console.log("#ok_perfil click");
            dao.saveProfile();
        });

        $('#modificardosis').click(function() {
            if (global.debug)
                console.log("#modificardosis click");
            Artres.keyboard.show('#resultado2', 3);
        });

        $('#nuevoinr').click(function() {
            if (global.debug)
                console.log("#nuevoinr click");
            $('#resultado').attr("placeholder", '');
            $('#modificainr-link').text('Nuevo INR');
            var fechaHoy = new Date();
            var dia = fechaHoy.getDate();
            if (dia < 10)
                dia = '0' + dia;
            var mes = fechaHoy.getMonth();
            mes = mes + 1;
            if (mes < 10)
                mes = '0' + mes;
            var year = fechaHoy.getFullYear();
            fechaHoy = dia + '/' + mes + '/' + year;
            $('#fechaActual').html(fechaHoy);
            Artres.keyboard.show('#resultado', 3);
        });
        $('#edit_fecha').click(function() {
            $('#dateInr').val(fechaHoy());
        });
        $('#modificarFechaRevision').click(function() {
            $('#dateRevision').val(fechaHoy());
        });
        function fechaHoy() {
            var fechaHoy = new Date();
            var dia = fechaHoy.getDate();
            if (dia < 10)
                dia = '0' + dia;
            var mes = fechaHoy.getMonth();
            mes = mes + 1;
            if (mes < 10)
                mes = '0' + mes;
            var year = fechaHoy.getFullYear();
            fechaHoy = dia + '/' + mes + '/' + year;
            return fechaHoy;
        }


        $('#modificarinr').click(function() {
            if (global.debug)
                console.log("#modificarinr click");
            // Cargamos el valor de INR actual en el campo
            $('#resultado').attr("placeholder", $("#tuvalorinr").html());
            Artres.keyboard.show('#resultado', 3);
        });

        $('#perfilButton').click(function() {
            if (global.debug)
                console.log("#perfilButton click");
            if (window.localStorage.getItem("alertas") == 1) {
                $('#alertas').addClass('active').val(1);
            }
            if (window.localStorage.getItem("email") == 1) {
                $('#emailPerfil').addClass('active').val(1);
            }
            if (global.disableServer) {
                $('#lastSync').html('No conectado.');
            } else {
                if (dao.getLastSync() == null) {
                    // Esto no debería ser posible
                    $('#lastSync').html('Nunca.');
                } else {
                    // Mostramos la ultima sincronizacion con formato dd/mm/yyyy hh:mm
                    $('#lastSync').html(dao.dateToStr(dao.getLastSync(), false, false, true));
                }
            }
        });

        $('#estadisticaBoton').click(function() {
            if (global.debug)
                console.log("#estadisticaBoton click");
            app.db.transaction(dao.inrMonth, dao.errorCB);
        });

        $('#dosisGeneral_link').click(function() {
            Artres.keyboard.show('#dosisGeneralResultado', 3);
        });

        $('#ok_dosisgeneral').click(function() {
            if (global.debug)
                console.log("#ok_dosisgeneral click");
            dao.dosisGeneral($('#dosisGeneralResultado').val());
        });

        $("#historicorev").click(function() {
            if (global.debug)
                console.log("#historicorev click");
            app.db.transaction(dao.historicoRev, dao.errorCB);
        });
    },
    // Evento generico para todos los enlaces
    clickEvent: function(screen) {
        if (app.actualScreen == screen)
            return false;

        app.actualScreen = screen;
        var showString = $(screen).attr('data-show');
        var setActive = $(screen).attr('set-active');

        if (global.debug)
            console.log("clickEvent function");
        if (global.debug)
            console.log("screen: " + screen);
        if (global.debug)
            console.log("showString: " + showString);
        if (global.debug)
            console.log("setActive: " + setActive);

        //si tiene definido data-header mostrarlo
        if (showString != undefined && showString != '') {
            var elem = showString.split(" ");
            //Convert all in ids;
            for (i = 0; i < elem.length; i++) {
                var e = elem[i];
                elem[i] = e.trim();
            }
            var elements = $(".autohide");
            for (i = 0; i < elements.length; i++) {
                if (elem.indexOf($(elements[i]).attr("id")) != -1) {
                    $(elements[i]).removeClass("ocult").addClass("transition");
                } else {
                    $(elements[i]).addClass("ocult transition");
                }
            }
        } else {
            //Ocultar todos los elementos con autohide
            $(".autohide").addClass("ocult transition");
        }

        // Borramos la clase active de todos los enlaces		
        $('a').removeClass('active');
        if (setActive != undefined && setActive != '') {
            // Marcamos el enlace pulsado como activo
            $('#' + setActive).addClass('active');
        }

        app.slider.slidePage($(screen));
    },
    init: function() {
        if (global.debug)
            console.log("init function");
        //Pone la hora a la que tiene que tomar la dosis
        var hora='--:--';
        if(window.localStorage.getItem("horaAlertas")!='' & window.localStorage.getItem("minutoAlertas")!='')
            hora=window.localStorage.getItem("horaAlertas")+':'+window.localStorage.getItem("minutoAlertas");
        $("#fechaDosis").html(hora);
        // init scrolls
        //$('#graficaTactil').css('width', screen.width+200);
        //$('#grafica').css('width', ($(window).width() + 30) + "px");
        //$('#grafica').css('width', screen.width+200);
        //$('#graficaTactil').css('width', 1200);
        //$('#graficaTactil').css('height', ($(document).height() - 130) + "px");
        $('#grafica-wrapper').css('height', ($(document).height() - 130) + "px");
        $('.contentGrafica').css('height', ($(document).height() - 190) + "px");
        $('#leftGrafica').css('height', ($(document).height() - 190) + "px");
        //$('#grafica').css('width', 1200);
        $('#grafica').css('height', ($(document).height() - 130) + "px");
        $('#scrollAyudaEmail').css('height', ($(window).height() - 150) + "px");
        $('#scroll-revisiones').css('height', ($(window).height() - 110) + "px");
        //$('#grafica').css('height', $(document).height() + "px");
        //$('#calendario-dosis-listadias').css('height',($( window ).height()-150)+"px");
        
        //$('#leftGrafica span').css('height', ($('#leftGrafica').height()/16.39) + "px");
        $('#leftGrafica span').css('height', (($('#leftGrafica').height()*6.15)/100) + "px");

        $('#scrollPregunta0').css('height', ($(window).height() - 150) + "px");
        $('#scrollPregunta1').css('height', ($(window).height() - 150) + "px");
        $('#scrollPregunta2').css('height', ($(window).height() - 150) + "px");
        $('#scrollPregunta3').css('height', ($(window).height() - 150) + "px");
        $('#scrollPregunta4').css('height', ($(window).height() - 150) + "px");
        $('#scrollPregunta5').css('height', ($(window).height() - 150) + "px");
        $('#scrollPregunta6').css('height', ($(window).height() - 150) + "px");
        $('#scrollPregunta7').css('height', ($(window).height() - 150) + "px");
        $('#scrollPregunta8').css('height', ($(window).height() - 150) + "px");
        //Scroll Historico INR
        $('#mininrcontenido').css('height', ($(window).height() - 75) + "px");
        //$('#scrollguia').css('height',($( window ).height()-137)+"px");
        $('#scrollguia').css('height', ($(window).height() - 78) + "px");
        // $('#scrollPerfil').css('height',($( window ).height()-147)+"px");
        $('#miperfil-content').css('height', ($(window).height() - 130) + "px");
        // app version
        $('#appVersion').html(global.APP_VERSION);
        $('#appVersion').html(app.appVersion);
        // init database
        app.db = window.openDatabase("appfeasan", "1.0", "db", 1000000);
        app.db.transaction(dao.populateDB, dao.errorCB, dao.successCB);
        //Avoid the 300ms Click Delay
        FastClick.attach(document.body);
        // init slider
        app.slider = new PageSlider($("#content"));
    },
};
