/* 
 * Servicio en segundo plano encargado de las notificaciones push.
 */

var bgService = {
	service: null,
	fecha: null,

	init: function(fecha) {
		if (global.debug) console.log("init function");
		bgService.fecha = fecha;
		bgService.service = cordova.require('com.red_folder.phonegap.plugin.backgroundservice.BackgroundService');
		bgService.service.startService(
			function(r){bgService.handleSuccess(r)}, //start the service and set its callbacks
			function(){bgService.handleError(e)});
	},
	
	stop: function() {
		if (global.debug) console.log("stop function");
		bgService.service.stopService(
			function(r){bgService.handleSuccess(r)}, 
			function(e){bgService.handleError(e)});
	},
	
	handleSuccess: function(data) {
		if (global.debug) console.log("handleSuccess function");
		if (data.ServiceRunning){ //service has been started
            bgService.setConfig(); //will set the parameters of your java class (this call is OPTIONAL)
            bgService.enableTimer(); // will set and start the timer =&amp;gt; execute doWork()
			
        } else { 
			//service has been stopped 
            bgService.disableTimer();
        }
	},
	
	enableTimer: function() {
		if (global.debug) console.log("enableTimer function");
		bgService.service.enableTimer(20000,
			function(r){bgService.handleSuccessTimer(r)},
			function(e){bgService.handleError(e)});
	},
	
	setConfig: function() {
		if (global.debug) console.log("setConfig function");
        var config = { 
                        'Date' : bgService.fecha
                     }; 
        bgService.service.setConfiguration(config,
            function(r){bgService.handleSuccessConfig(r)},
            function(e){bgService.handleError(e)});
	},
	
	handleSuccessTimer: function(data) {
		if (global.debug) console.log("handleSuccessTimer function");
		if (global.debug) console.log(JSON.stringify(data)); //get all the info you need
	},
	
	handleSuccessConfig: function(data) {
		if (global.debug) console.log("handleSuccessConfig function");
		if (global.debug) console.log(JSON.stringify(data)); //get all the info you need
	},
	
	handleError: function(data) {
		if (global.debug) console.log("Error: " + data.ErrorMessage); //basic error
		if (global.debug) console.log(JSON.stringify(data)); //get all the info you need
	},
	
	
};